retcod
[build.git] / lbuild-nightly.sh
1 #!/bin/bash
2
3 COMMANDPATH=$0
4 COMMAND=$(basename $0)
5
6 # old guests have e.g. mount in /bin but this is no longer part of 
7 # the standard PATH in recent hosts after usrmove, so let's keep it simple
8 export PATH=$PATH:/bin:/sbin
9
10 # default values, tunable with command-line options
11 DEFAULT_FCDISTRO=f20
12 DEFAULT_PLDISTRO=planetlab
13 DEFAULT_PERSONALITY=linux64
14 DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
15 DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
16
17 # default gpg path used in signing yum repo
18 DEFAULT_GPGPATH="/etc/planetlab"
19 # default email to use in gpg secring
20 DEFAULT_GPGUID="root@$( /bin/hostname )"
21
22 DEFAULT_TESTCONFIG="default"
23 # for passing args to run_log
24 RUN_LOG_EXTRAS=""
25
26 # for publishing results, and the tests settings
27 x=$(hostname)
28 y=$(hostname|sed -e s,inria,,)
29 # INRIA defaults
30 if [ "$x" != "$y" ] ; then
31     DEFAULT_WEBPATH="/build/@PLDISTRO@/"
32     DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
33     # this is where the buildurl is pointing towards
34     DEFAULT_WEBROOT="/build/"
35     DEFAULT_TESTMASTER="testmaster.onelab.eu"
36 else
37     DEFAULT_WEBPATH="/build/@FCDISTRO@/@PLDISTRO@/"
38     DEFAULT_TESTBUILDURL="http://build.planet-lab.org/"
39     # this is where the buildurl is pointing towards
40     DEFAULT_WEBROOT="/build/"
41     DEFAULT_TESTMASTER="manager.test.planet-lab.org"
42 fi    
43
44 ####################
45 # assuming vm runs in UTC
46 DATE=$(date +'%Y.%m.%d')
47 BUILD_BEG=$(date +'%H:%M')
48 BUILD_BEG_S=$(date +'%s')
49
50 # still using /vservers for legacy reasons
51 # as far as the build & test infra, we could adopt a new name
52 # but the PL code still uses this name for now, so let's keep it simple
53 function rootdir () {
54     slice=$1; shift
55     echo /vservers/$slice
56 }
57 function logfile () {
58     slice=$1; shift
59     echo /vservers/$slice.log.txt
60 }
61
62 # wrap a quick summary of suspicious stuff
63 # this is to focus on installation that go wrong
64 # use with care, a *lot* of other things can go bad as well
65 function summary () {
66     from=$1; shift
67     echo "******************** BEG SUMMARY" 
68     python - $from <<EOF
69 #!/usr/bin/env python
70 # read a full log and tries to extract the interesting stuff
71
72 import sys,re
73 m_show_line=re.compile(".* (BEG|END) (RPM|LXC).*|.*'boot'.*|\* .*| \* .*|.*is not installed.*|.*PROPFIND.*|.* (BEG|END).*:run_log.*|.* Within LXC (BEG|END) .*|.* MAIN (BEG|END).*")
74 m_installing_any=re.compile('\r  (Installing:[^\]]*]) ')
75 m_installing_err=re.compile('\r  (Installing:[^\]]*])(..+)')
76 m_installing_end=re.compile('Installed:.*')
77 m_installing_doc1=re.compile("(.*)install-info: No such file or directory for /usr/share/info/\S+(.*)")
78 m_installing_doc2=re.compile("(.*)grep: /usr/share/info/dir: No such file or directory(.*)")
79
80 def summary (filename):
81
82     try:
83         if filename=="-":
84             filename="stdin"
85             f=sys.stdin
86         else:
87             f=open(filename)
88         echo=False
89         for line in f.xreadlines():
90             # first off : discard warnings related to doc
91             if m_installing_doc1.match(line):
92                 (begin,end)=m_installing_doc1.match(line).groups()
93                 line=begin+end
94             if m_installing_doc2.match(line):
95                 (begin,end)=m_installing_doc2.match(line).groups()
96                 line=begin+end
97             # unconditionnally show these lines
98             if m_show_line.match(line):
99                 print '>>>',line,
100             # an 'installing' line with messages afterwards : needs to be echoed
101             elif m_installing_err.match(line):
102                 (installing,error)=m_installing_err.match(line).groups()
103                 print '>>>',installing
104                 print '>>>',error
105                 echo=True
106             # closing an 'installing' section
107             elif m_installing_end.match(line):
108                 echo=False
109             # any 'installing' line
110             elif m_installing_any.match(line):
111                 if echo: 
112                     installing=m_installing_any.match(line).group(1)
113                     print '>>>',installing
114                 echo=False
115             # print lines when echo is true
116             else:
117                 if echo: print '>>>',line,
118         f.close()
119     except:
120         print 'Failed to analyze',filename
121
122 for arg in sys.argv[1:]:
123     summary(arg)
124 EOF
125     echo "******************** END SUMMARY" 
126 }
127
128 ### we might build on a box other than the actual web server
129 # utilities for handling the pushed material (rpms, logfiles, ...)
130 function webpublish_misses_dir () { ssh root@${WEBHOST}  "bash -c \"test \! -d $1\"" ; }
131 function webpublish () { ssh root@${WEBHOST} "$@" ; }
132 function webpublish_cp_local_to_remote () { scp $1 root@${WEBHOST}:$2 ; }
133 function webpublish_cp_stdin_to_file () { ssh root@${WEBHOST} cat \> $1; }
134 function webpublish_append_stdin_to_file () { ssh root@${WEBHOST} cat \>\> $1; }
135 # provide remote dir as first argument, so any number of local files can be passed next
136 function webpublish_rsync_dir () { rsync --archive --delete $VERBOSE $2 root@${WEBHOST}:$1 ; }
137 function webpublish_rsync_files () {
138     remote="$1"; shift
139     rsync --archive $VERBOSE "$@" root@${WEBHOST}:"$remote" ;
140 }
141
142 # Notify recipient of failure or success, manage various stamps 
143 function failure() {
144     set -x
145     # early stage ? - let's not create /build/@PLDISTRO@
146     if test -z "$WEBLOG" ; then
147         WEBHOST=$(hostname)
148         WEBPATH=/tmp
149         WEBBASE=/tmp/lbuild-early-$(date +%Y-%m-%d)
150         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
151     fi
152     webpublish mkdir -p $WEBBASE ||:
153     webpublish_cp_local_to_remote $LOG $WEBLOG ||:
154     summary $LOG | webpublish_append_stdin_to_file $WEBLOG ||:
155     (echo -n "============================== $COMMAND: failure at " ; date ; \
156         webpublish tail --lines=1000 $WEBLOG) | \
157         webpublish_cp_stdin_to_file $WEBBASE.ko ||:
158     if [ -n "$MAILTO" ] ; then
159         ( \
160             echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
161             echo "To: $MAILTO" ; \
162             echo "see build results at        $WEBBASE_URL" ; \
163             echo "including full build log at $WEBBASE_URL/log.txt" ; \
164             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
165             echo "........................................" ; \
166             webpublish tail --lines=1000 $WEBLOG ) | \
167             sendmail $MAILTO
168     fi
169     exit 1
170 }
171
172 function success () {
173     set -x
174     # early stage ? - let's not create /build/@PLDISTRO@
175     if test -z "$WEBLOG" ; then
176         WEBHOST=$(hostname)
177         WEBPATH=/tmp
178         WEBLOG=/tmp/lbuild-early-$(date +%Y-%m-%d).log.txt
179     fi
180     webpublish mkdir -p $WEBBASE
181     webpublish_cp_local_to_remote $LOG $WEBLOG
182     summary $LOG | webpublish_append_stdin_to_file $WEBLOG
183     if [ -n "$DO_TEST" ] ; then
184         short_message="PASS"
185         ext="pass"
186         if [ -n "$IGNORED" ] ; then short_message="PASS/WARN"; ext="warn"; fi
187         ( \
188             echo "Successfully built and tested" ; \
189             echo "see build results at        $WEBBASE_URL" ; \
190             echo "including full build log at $WEBBASE_URL/log.txt" ; \
191             echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
192             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
193             ) | webpublish_cp_stdin_to_file $WEBBASE.$ext
194         webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
195     else
196         short_message="PKGOK"
197         ( \
198             echo "Successful package-only build, no test requested" ; \
199             echo "see build results at        $WEBBASE_URL" ; \
200             echo "including full build log at $WEBBASE_URL/log.txt" ; \
201             ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
202         webpublish rm -f $WEBBASE.ko
203     fi
204     BUILD_END=$(date +'%H:%M')
205     BUILD_END_S=$(date +'%s')
206     if [ -n "$MAILTO" ] ; then
207         ( \
208             echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
209             echo "To: $MAILTO" ; \
210             echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
211             echo "see build results at        $WEBBASE_URL" ; \
212             echo "including full build log at $WEBBASE_URL/log.txt" ; \
213             [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
214             [ -n "$IGNORED" ] && echo "WARNING: some tests steps failed but were ignored - see trace file" ; \
215             echo "BUILD TIME: begin $BUILD_BEG -- end $BUILD_END -- duration $(($BUILD_END_S-$BUILD_BEG_S))" ; \
216             ) | sendmail $MAILTO
217     fi
218     # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
219     # doesn't fix the problem, I'll remove it -- Sapan.
220     sleep 5
221     exit 0
222 }
223
224 ##############################
225 # manage root / container contexts
226 function in_root_context () {
227     rpm -q libvirt > /dev/null 
228 }
229
230 # run in the vm - do not manage success/failure, will be done from the root ctx
231 function build () {
232     set -x
233     set -e
234
235     echo -n "============================== Starting $COMMAND:build on "
236     date
237
238     cd /build
239     show_env
240     
241     echo "Running make IN $(pwd)"
242     
243     # stuff our own variable settings
244     MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
245     MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
246     MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
247     MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
248     MAKEVARS=("MAILTO=${MAILTO}" "${MAKEVARS[@]}")
249     MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
250     MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
251     MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
252
253     MAKEVARS=("BASE=${BASE}" "${MAKEVARS[@]}")
254
255     # initialize latex
256     /build/latex-first-run.sh || :
257
258     # stage1
259     make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true 
260     # versions
261     make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
262     # actual stuff
263     make -C /build $DRY_RUN "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
264
265 }
266
267 # this was formerly run in the myplc-devel chroot but now is run in the root context,
268 # this is so that the .ssh config gets done manually, and once and for all
269 function run_log () {
270     set -x
271     set -e
272     trap failure ERR INT
273
274     echo "============================== BEG $COMMAND:run_log on $(date)"
275
276     ### the URL to the RPMS/<arch> location
277     # f12 now has everything in i686; try i386 first as older fedoras have both
278     url=""
279     for a in i386 i686 x86_64; do
280         archdir=$(rootdir $BASE)/build/RPMS/$a
281         if [ -d $archdir ] ; then
282             # where was that installed
283             url=$(echo $archdir | sed -e "s,$(rootdir $BASE)/build,${WEBPATH}/${BASE},")
284             url=$(echo $url | sed -e "s,${WEBROOT},${TESTBUILDURL},")
285             break
286         fi
287     done
288
289     if [ -z "$url" ] ; then
290         echo "$COMMAND: Cannot locate arch URL for testing"
291         failure
292         exit 1
293     fi
294
295     testmaster_ssh="root@${TESTMASTER}"
296
297     # test directory name on test box
298     testdir=${BASE}
299
300     # clean it
301     ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
302
303     # check it out in the build
304     virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "make -C /build tests-module"
305     
306     # push it onto the testmaster - just the 'system' subdir is enough
307     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
308     # toss the build in the bargain, so the tests don't need to mess with extracting it
309     rsync --verbose --archive $(rootdir $BASE)/build/MODULES/build ${testmaster_ssh}:${BASE}/
310
311     # invoke test on testbox - pass url and build url - so the tests can use vtest-init-lxc.sh
312     run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
313
314     # temporarily turn off set -e
315     set +e
316     ssh 2>&1 -n ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all; retcod=$?
317     set -e
318     
319     # interpret retcod of TestMain.py; 2 means there were ignored steps that failed
320     case $retcod in
321         0) success=true; IGNORED="" ;;
322         1) success=true; IGNORED=true ;;
323         *) success="" ;; 
324     esac
325
326     # gather logs in the build vm
327     mkdir -p $(rootdir $BASE)/build/testlogs
328     rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ $(rootdir $BASE)/build/testlogs
329     # push them to the build web
330     chmod -R a+r $(rootdir $BASE)/build/testlogs/
331     webpublish_rsync_dir $WEBPATH/$BASE/testlogs/ $(rootdir $BASE)/build/testlogs/
332
333     echo  "============================== END $COMMAND:run_log on $(date)"
334
335     if [ -z "$success" ] ; then
336         echo "Tests have failed - bailing out"
337         failure
338     fi
339     
340 }
341
342 # this part won't work if WEBHOST does not match the local host
343 # would need to be made webpublish_* compliant
344 # but do we really need this feature anyway ?
345 function sign_node_packages () {
346
347     echo "Signing node packages"
348     
349     need_createrepo=""
350
351     repository=$WEBPATH/$BASE/RPMS/
352     # the rpms that need signing
353     new_rpms=
354     # and the corresponding stamps
355     new_stamps=
356
357     for package in $(find $repository/ -name '*.rpm') ; do
358         stamp=$repository/signed-stamps/$(basename $package).signed
359         # If package is newer than signature stamp
360         if [ $package -nt $stamp ] ; then
361             new_rpms="$new_rpms $package"
362             new_stamps="$new_stamps $stamp"
363         fi
364         # Or than createrepo database
365         [ $package -nt $repository/repodata/repomd.xml ] && need_createrepo=true
366     done
367
368     if [ -n "$new_rpms" ] ; then
369         # Create a stamp once the package gets signed
370         mkdir $repository/signed-stamps 2> /dev/null
371         
372         # Sign RPMS. setsid detaches rpm from the terminal,
373         # allowing the (hopefully blank) GPG password to be
374         # entered from stdin instead of /dev/tty.
375         echo | setsid rpm \
376             --define "_signature gpg" \
377             --define "_gpg_path $GPGPATH" \
378             --define "_gpg_name $GPGUID" \
379             --resign $new_rpms && touch $new_stamps
380     fi
381
382      # Update repository index / yum metadata. 
383     if [ -n "$need_createrepo" ] ; then
384         echo "Indexing node packages after signing"
385         if [ -f $repository/yumgroups.xml ] ; then
386             createrepo --quiet -g yumgroups.xml $repository
387         else
388             createrepo --quiet $repository
389         fi
390     fi
391 }
392
393 function show_env () {
394     set +x
395     echo FCDISTRO=$FCDISTRO
396     echo PLDISTRO=$PLDISTRO
397     echo PERSONALITY=$PERSONALITY
398     echo BASE=$BASE
399     echo BUILD_SCM_URL=$BUILD_SCM_URL
400     echo MAKEVARS="${MAKEVARS[@]}"
401     echo DRY_RUN="$DRY_RUN"
402     echo PLDISTROTAGS="$PLDISTROTAGS"
403     # this does not help, it's not yet set when we run show_env
404     #echo WEBPATH="$WEBPATH"
405     echo TESTBUILDURL="$TESTBUILDURL"
406     echo WEBHOST="$WEBHOST"
407     if in_root_context ; then
408         echo PLDISTROTAGS="$PLDISTROTAGS"
409     else
410         if [ -f /build/$PLDISTROTAGS ] ; then
411             echo "XXXXXXXXXXXXXXXXXXXX Contents of tags definition file /build/$PLDISTROTAGS"
412             cat /build/$PLDISTROTAGS
413             echo "XXXXXXXXXXXXXXXXXXXX end tags definition"
414         else
415             echo "XXXXXXXXXXXXXXXXXXXX Cannot find tags definition file /build/$PLDISTROTAGS, assuming remote pldistro"
416         fi
417     fi
418     set -x
419 }
420
421 function setupssh () {
422     base=$1; shift
423     sshkey=$1; shift
424     
425     if [ -f ${sshkey} ] ; then
426         SSHDIR=$(rootdir ${base})/root/.ssh
427         mkdir -p ${SSHDIR}
428         cp $sshkey ${SSHDIR}/thekey
429         (echo "host *"; \
430             echo "  IdentityFile ~/.ssh/thekey"; \
431             echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
432         chmod 700 ${SSHDIR}
433         chmod 400 ${SSHDIR}/*
434     else 
435         echo "WARNING : could not find provided ssh key $sshkey - ignored"
436     fi
437 }
438
439 function usage () {
440     echo "Usage: $COMMAND [option] [var=value...] make-targets"
441     echo "Supported options"
442     echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
443     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
444     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
445     echo " -m mailto - no default"
446     echo " -s build_scm_url - git URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
447     echo "    define GIT tag or branch name appending @tagname to url"
448     echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
449     echo " -b base - defaults to $DEFAULT_BASE"
450     echo "    @NAME@ replaced as appropriate"
451     echo " -o base: (overwrite) do not re-create vm, re-use base instead"
452     echo "    the -f/-d/-p/-m/-s/-t options are uneffective in this case"
453     echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
454     echo " -y {pl,pg} - passed to run_log"
455     echo " -e step - passed to run_log"
456     echo " -i step - passed to run_log"
457     echo " -X : passes --lxc to run_log"
458     echo " -S : passes --vs to run_log"
459     echo " -x <run_log_args> - a hook to pass other arguments to run_log"
460     echo " -w webpath - defaults to $DEFAULT_WEBPATH"
461     echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL; this is also used to get the hostname where to publish builds"
462     echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
463     echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
464     echo " -Y - sign yum repo in webpath"
465     echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
466     echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
467     echo " -K sshkey - specify ssh key to use when reaching git over ssh"
468     echo " -S - do not publish source rpms"
469     echo " -B - run build only"
470     echo " -T - run test only"
471     echo " -n - dry-run: -n passed to make - vm gets created though - no mail sent"
472     echo " -v - be verbose"
473     echo " -7 - uses weekday-@FCDISTRO@ as base"
474     echo " --build-branch branch - build using the branch from build module"
475     exit 1
476 }
477
478 function main () {
479
480     set -e
481
482     # parse arguments
483     MAKEVARS=()
484     MAKETARGETS=()
485     DRY_RUN=
486     DO_BUILD=true
487     DO_TEST=true
488     PUBLISH_SRPMS=true
489     SSH_KEY=""
490     SIGNYUMREPO=""
491
492     OPTS_ORIG=$@
493     OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:i:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
494     if [ $? != 0 ]
495     then
496         usage
497     fi
498     eval set -- "$OPTS"
499     while true; do
500         case $1 in
501             -f) FCDISTRO=$2; shift 2 ;;
502             -d) PLDISTRO=$2; shift 2 ;;
503             -p) PERSONALITY=$2; shift 2 ;;
504             -m) MAILTO=$2; shift 2 ;;
505             -s) BUILD_SCM_URL=$2; shift 2 ;;
506             -t) PLDISTROTAGS=$2; shift 2 ;;
507             -b) BASE=$2; shift 2 ;;
508             -o) OVERBASE=$2; shift 2 ;;
509             -c) TESTCONFIG="$TESTCONFIG $2"; shift 2 ;;
510             ########## passing stuff to run_log
511             # -y foo -> run_log -y foo
512             -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --rspec-style $2"; shift 2 ;;
513             # -e foo -> run_log -e foo
514             -e) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --exclude $2"; shift 2 ;;
515             -i) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --ignore $2"; shift 2 ;;
516             # -X -> run_log --lxc
517             -X) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --lxc"; shift;;
518             # -S -> run_log --vs
519             -S) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --vs"; shift;;
520             # more general form to pass args to run_log
521             # -x foo -> run_log foo
522             -x) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS $2"; shift 2;;
523             ##########
524             -w) WEBPATH=$2; shift 2 ;;
525             -W) TESTBUILDURL=$2; shift 2 ;;
526             -r) WEBROOT=$2; shift 2 ;;
527             -M) TESTMASTER=$2; shift 2 ;;
528             -Y) SIGNYUMREPO=true; shift ;;
529             -g) GPGPATH=$2; shift 2 ;;
530             -u) GPGUID=$2; shift 2 ;;
531             -K) SSH_KEY=$2; shift 2 ;;
532             -S) PUBLISH_SRPMS="" ; shift ;;
533             -B) DO_TEST= ; shift ;;
534             -T) DO_BUILD= ; shift;;
535             -n) DRY_RUN="-n" ; shift ;;
536             -v) set -x ; VERBOSE="-v" ; shift ;;
537             -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
538             -P) PREINSTALLED="-P $2"; shift 2;;
539             -h) usage ; shift ;;
540             --) shift; break ;;
541         esac
542     done
543
544     # preserve options for passing them again later, together with expanded base
545     options=$OPTS_ORIG
546
547     # allow var=value stuff; 
548     for target in "$@" ; do
549         # check if contains '='
550         target1=$(echo $target | sed -e s,=,,)
551         if [ "$target" = "$target1" ] ; then
552             MAKETARGETS=(${MAKETARGETS[@]} "$target")
553         else
554             MAKEVARS=(${MAKEVARS[@]} "$target")
555         fi
556     done
557     
558     # set defaults
559     [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
560     [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
561     [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
562     [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
563     [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
564     [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
565     [ -z "$TESTBUILDURL" ] && TESTBUILDURL="$DEFAULT_TESTBUILDURL"
566     [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
567     [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
568     [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
569     [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
570     [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
571     [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
572
573     [ -n "$DRY_RUN" ] && MAILTO=""
574
575     # elaborate the extra args to be passed to run_log
576     for config in ${TESTCONFIG} ; do
577         RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
578     done
579     
580         
581     if [ -n "$OVERBASE" ] ; then
582         sedargs="-e s,@DATE@,${DATE},g"
583         BASE=$(echo ${OVERBASE} | sed $sedargs)
584     else
585         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
586         BASE=$(echo ${BASE} | sed $sedargs)
587     fi
588
589     ### elaborate mail subject
590     if [ -n "$DO_BUILD" -a -n "$DO_TEST" ] ; then
591         MAIL_SUBJECT="full"
592     elif [ -n "$DO_BUILD" ] ; then
593         MAIL_SUBJECT="pkg-only"
594     elif [ -n "$DO_TEST" ] ; then
595         MAIL_SUBJECT="test-only"
596     fi
597     if [ -n "$OVERBASE" ] ; then
598         MAIL_SUBJECT="${MAIL_SUBJECT} rerun"
599     else
600         MAIL_SUBJECT="${MAIL_SUBJECT} fresh"
601     fi
602     short_hostname=$(hostname | cut -d. -f1)
603     MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
604
605     ### compute WEBHOST from TESTBUILDURL 
606     # this is to avoid having to change the builds configs everywhere
607     # simplistic way to extract hostname from a URL
608     WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
609
610     if ! in_root_context ; then
611         # in the vm
612         echo "==================== Within LXC BEG $(date)"
613         build
614         echo "==================== Within LXC END $(date)"
615
616     else
617         trap failure ERR INT
618         # we run in the root context : 
619         # (*) create or check for the vm to use
620         # (*) copy this command in the vm
621         # (*) invoke it
622         
623         if [ -n "$OVERBASE" ] ; then
624             ### Re-use a vm (finish an unfinished build..)
625             if [ ! -d $(rootdir ${BASE}) ] ; then
626                 echo $COMMAND : cannot find vm $BASE
627                 exit 1
628             fi
629             # manage LOG - beware it might be a symlink so nuke it first
630             LOG=$(logfile ${BASE})
631             rm -f $LOG
632             exec > $LOG 2>&1
633             set -x
634             echo "XXXXXXXXXX $COMMAND: using existing vm $BASE" $(date)
635             # start in case e.g. we just rebooted
636             virsh -c lxc:/// start ${BASE} || :
637             # retrieve environment from the previous run
638             FCDISTRO=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/getdistroname.sh)
639             BUILD_SCM_URL=$(virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip +build-GITPATH")
640             # for efficiency, crop everything in one make run
641             tmp=/tmp/${BASE}-env.sh
642             virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "make --no-print-directory -C /build stage1=skip \
643                 ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT" > $tmp
644             . $tmp
645             rm -f $tmp
646             # update build
647             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
648             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "cd /build; git pull; make tests-clean"
649             # make sure we refresh the tests place in case it has changed
650             rm -f /build/MODULES/tests
651             options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
652             [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
653             [ -n "$MAILTO" ] && options=(${options[@]} -m $MAILTO)
654             [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
655             [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
656             [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
657             show_env
658         else
659             # create vm: check it does not exist yet
660             i=
661             while [ -d $(rootdir ${BASE})${i} ] ; do
662                 # we name subsequent builds <base>-n<i> so the logs and builds get sorted properly
663                 [ -z ${i} ] && BASE=${BASE}-n
664                 i=$((${i}+1))
665                 if [ $i -gt 100 ] ; then
666                     echo "$COMMAND: Failed to create build vm $(rootdir ${BASE})${i}"
667                     exit 1
668                 fi
669             done
670             BASE=${BASE}${i}
671             # need update
672             # manage LOG - beware it might be a symlink so nuke it first
673             LOG=$(logfile ${BASE})
674             rm -f $LOG
675             exec > $LOG 2>&1 
676             set -x
677             echo "XXXXXXXXXX $COMMAND: creating vm $BASE" $(date)
678             show_env
679
680             ### extract the whole build - much simpler
681             tmpdir=/tmp/$COMMAND-$$
682             GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
683             GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
684             GIT_TAG=${GIT_TAG:-master}
685             mkdir -p $tmpdir; git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -
686
687             # Create lxc vm
688             cd $tmpdir
689             ./lbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} ${PREINSTALLED} ${BASE} 
690             # cleanup
691             cd -
692             rm -rf $tmpdir
693             # Extract build again - in the vm
694             [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
695             # xxx not working as of now - waiting for Sapan to look into this
696             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
697         fi
698         echo "XXXXXXXXXX $COMMAND: preparation of vm $BASE done" $(date)
699
700         # The log inside the vm contains everything
701         LOG2=$(rootdir ${BASE})/log.txt
702         (echo "==================== BEG LXC Transcript of vm creation" ; \
703          cat $LOG ; \
704          echo "==================== END LXC Transcript of vm creation" ; \
705          echo "xxxxxxxxxx Messing with logs, symlinking $LOG2 to $LOG" ) >> $LOG2
706         ### not too nice : nuke the former log, symlink it to the new one
707         rm $LOG; ln -s $LOG2 $LOG
708         LOG=$LOG2
709         # redirect log again
710         exec >> $LOG 2>&1 
711
712         sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
713         WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
714         webpublish mkdir -p ${WEBPATH}
715
716         # where to store the log for web access
717         WEBBASE=${WEBPATH}/${BASE}
718         WEBLOG=${WEBPATH}/${BASE}/log.txt
719         # compute the log URL - inserted in the mail messages for convenience
720         WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
721     
722         if [ -n "$DO_BUILD" ] ; then 
723
724             # invoke this command into the build directory of the vm
725             cp $COMMANDPATH $(rootdir ${BASE})/build/
726
727             # invoke this command in the vm for building (-T)
728             virsh -c lxc:/// lxc-enter-namespace ${BASE} /bin/bash -c "chmod +x /build/$COMMAND"
729             virsh -c lxc:/// lxc-enter-namespace ${BASE} /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
730         fi
731
732         # publish to the web so run_log can find them
733         set +e
734         webpublish rm -rf $WEBPATH/$BASE 
735         # guess if we've been doing any debian-related build
736         if [ ! -f $(rootdir $BASE)/etc/debian_version  ] ; then
737             webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
738             webpublish_rsync_dir $WEBPATH/$BASE/RPMS/ $(rootdir $BASE)/build/RPMS/
739             [[ -n "$PUBLISH_SRPMS" ]] && webpublish_rsync_dir $WEBPATH/$BASE/SRPMS/ $(rootdir $BASE)/build/SRPMS/
740         else
741             # run scanpackages so we can use apt-get on this
742             # (not needed on fedora b/c this is done by the regular build already)
743             virsh -c lxc:/// lxc-enter-namespace $BASE /bin/bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
744             webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
745             webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ $(rootdir $BASE)/build/DEBIAN/*.deb 
746             webpublish_rsync_files $WEBPATH/$BASE/ $(rootdir $BASE)/build/Packages.gz
747         fi
748         # publish myplc-release if this exists
749         release=$(rootdir $BASE)/build/myplc-release
750         [ -f $release ] && webpublish_rsync_files $WEBPATH/$BASE $release
751         set -e
752
753         # create yum repo and sign packages.
754         if [ -n "$SIGNYUMREPO" ] ; then
755             # this script does not yet support signing on a remote (webhost) repo
756             sign_here=$(hostname) ; sign_web=$(webpublish hostname)
757             if [ "$hostname" = "$sign_here" ] ; then
758                 sign_node_packages
759             else
760                 echo "$COMMAND does not support signing on a remote yum repo"
761                 echo "you might want to turn off the -y option, or run this on the web server box itself"
762                 exit 1
763             fi
764         fi
765
766         if [ -n "$DO_TEST" ] ; then 
767             run_log
768         fi
769
770         success 
771
772         echo "==================== MAIN END $(date)"    
773     fi
774
775 }
776
777 ##########
778 main "$@"